#ifndef BLUECORE_MATERIAL_H
#define BLUECORE_MATERIAL_H

#include "ShaderManager.h"
#include "TextureManager.h"

namespace BlueCore
{

class Material
{
	typedef ref_ptr<Texture> TexturePtr;
	typedef std::pair<std::string, TexturePtr> TextureUnit;
	
	std::vector<TextureUnit> _Textures;
	ShaderProgram _ShaderProgram;
	bool Tangents;
	float Shininess;
	float Specular[4];
};

}
#endif /*MATERIAL_H_*/
